<script setup lang="ts">
import { watch, ref, computed, reactive } from "vue";
import type { ComputedRef } from "vue";
import type { ImageUpload, ImagePreview } from "@/models/image";
import { isImage, isValidUrl } from "@/utils/dom";
import BaseButton from "@/components/BaseButton.vue";
import BaseTextInput from "@/components/BaseTextInput.vue";
import BaseFileInput from "@/components/BaseFileInput.vue";
import ImageDropZone from "@/components/ImageDropZone.vue";

const props = defineProps<{ prefilledUpload?: ImageUpload }>();

const emit = defineEmits<{
  (e: "finish"): void;
  (e: "submit", formData: ImageUpload): void;
}>();

const form = reactive({
  label: props.prefilledUpload?.label || "",
  url: props.prefilledUpload?.url || "",
  file: props.prefilledUpload?.file as File | undefined,
});
const formError = ref("");
const isSubmitted = ref(false);

const previewImage: ComputedRef<ImagePreview | undefined> = computed(() => {
  if (!form.file || !isImage(form.file)) {
    return undefined;
  }

  return {
    name: form.file.name,
    url: URL.createObjectURL(form.file),
  };
});

watch(
  () => form.file,
  (newFile: File | undefined) => {
    if (!isImage(newFile)) {
      return;
    }

    // clear url and errors on valid file
    form.url = "";
    formError.value = "";
  }
);

watch(
  () => form.url,
  (newUrl: string) => {
    if (!isValidUrl(newUrl)) {
      return;
    }

    // clear file and errors on valid url
    form.file = undefined;
    formError.value = "";
  }
);

function handleSubmit() {
  if (!isValidUrl(form.url) && !isImage(form.file)) {
    formError.value = "Either url or image must be set.";
    return;
  }

  isSubmitted.value = true;
  emit("submit", form);
}
</script>

<template>
  <form
    class="form"
    aria-describedby="upload-img_form_error"
    @submit.prevent="handleSubmit"
    role="document"
    aria="image-upload-form"
  >
    <h2 class="heading">Add a new photo</h2>

    <div class="fields" :class="{ 'fields--form-error': formError }">
      <BaseTextInput
        id="image-submission_label"
        title="Label"
        type="text"
        name="label"
        placeholder="Enter photo label"
        v-model="form.label"
      />
      <BaseTextInput
        id="image-submission_url"
        title="Photo URL"
        type="url"
        name="url"
        placeholder="Enter photo URL"
        v-model="form.url"
        :validator="isValidUrl"
        error-msg="Entered URL is not valid."
      />

      <span class="conjuction" aria-hidden="true">or</span>

      <ImageDropZone
        :preview-image="previewImage"
        v-model="form.file"
        class="dropzone"
      />
      <span class="conjuction">or</span>

      <BaseFileInput
        id="image-submission_file"
        title="Choose a file"
        accept="image/*"
        name="file"
        v-model="form.file"
        errorMsg="Only images are allowed."
        :validator="isImage"
        removeMsg="Remove photo"
        class="file-field"
      />
    </div>

    <p
      v-if="formError"
      class="error"
      id="upload-img_form_error"
      aria-live="assertive"
    >
      {{ formError }}
    </p>

    <div class="buttons">
      <BaseButton
        type="button"
        class="btn btn-cancel"
        @click="$emit('finish')"
        aria-controls="image-upload-form"
        :disabled="isSubmitted"
      >
        Cancel
      </BaseButton>
      <BaseButton
        type="submit"
        class="btn btn-confirm"
        aria-controls="image-upload-form"
        :disabled="isSubmitted"
      >
        Submit
      </BaseButton>
    </div>
  </form>
</template>

<style lang="scss" scoped>
@use "@/assets/styles/bootstrap";

.form {
  padding: 2.4rem 3.2rem;
  font-weight: 500;
  line-height: 1.375;
  color: var(--color-grey-dark);
  display: grid;
  justify-items: center;
  row-gap: 2rem;
}

.heading {
  color: var(--color-dark);
}

.fields {
  justify-self: stretch;
  display: grid;
  row-gap: 2rem;

  &:not(&--form-error) {
    padding-bottom: 2rem;
  }
}

.file-field {
  justify-self: center;
}

.dropzone {
  display: grid;
  justify-items: center;
  row-gap: 3rem;
  padding: 4rem 0;
  background-color: var(--color-primary-background-light);
  border-radius: 1.2rem;
  line-height: 1.5;
  letter-spacing: -0.035em;
  color: var(--color-grey-dark);
}

.conjuction {
  line-height: 1;
  text-align: center;
  letter-spacing: -0.035em;
  color: var(--color-grey-light);
  text-transform: capitalize;
}

.error {
  color: var(--color-alert);
}

.buttons {
  display: flex;
  justify-content: center;
  align-items: center;
  column-gap: 2.4rem;
  width: 23.4rem;
  height: 4.8rem;

  @include bootstrap.respond-to-tiny-screen {
    column-gap: 2rem;
    width: 20rem;
  }
}

.btn-cancel {
  background-color: var(--color-alert);
  box-shadow: var(--box-shadow-size) var(--color-alert-shadow-light);
}

.btn-confirm {
  background-color: var(--color-success);
  box-shadow: var(--box-shadow-size) var(--color-success-shadow-light);
}

.btn {
  width: 100%;
  height: 100%;
}
</style>
